Scriptname mf_SpectatorCrowdsMainScript extends Quest  

SexLabFramework Property SexLab Auto

mf_SpectatorCrowdsConfig Property SCConfig Auto
mf_SpectatorCrowdsVariables Property SCConditional Auto

; Eventually the other threads would go here as well, but there is just the one thread for now
mf_SpectatorCrowdsThread00 Property SCThread00 Auto

string Property threadID Auto
bool sexStarted = false

Event OnInit()
	RegisterEvents()
	SexLab.PlayerRef.AddSpell(SpectatorZapperTarget)
	SexLab.PlayerRef.AddSpell(SpectatorZapperArea)
	SexLab.PlayerRef.AddSpell(SpectatorZapperMass)
endEvent

Function RegisterEvents()
	; Debug.Notification("OnLoad() - Registering for Morality Guards")
   	RegisterForModEvent("AnimationStart", "StartCallNPC")
	RegisterForModEvent("AnimationEnding", "StopCallNPC")
	RegisterForModEvent("AnimationEnd", "EndCallNPC")
endFunction

event StartCallNPC(string eventName, string argString, float argNum, form sender)
	if !sexStarted
		sslThreadController Controller = SexLab.HookController(argString)
		threadID = argString
		sexStarted=true
		SCThread00.SexStartDetected(Controller,threadID)
	endif
endEvent

event StopCallNPC(string eventName, string argString, float argNum, form sender)
	;MyDebug("Received stop call, argString is: " + argstring + " and threadid is " + threadID)
	if(argString == threadID)
		SCThread00.SexStopDetected()
	endif
endevent

event EndCallNPC(string eventName, string argString, float argNum, form sender)
	;MyDebug("Received end call, argString is: " + argstring + " and threadid is " + threadID)
	if(argString == threadID)	
		SCThread00.SexEndDetected()
		sexStarted = false
		MyDebug("sexStarted has been set to false")
	endif
endEvent

Event OnUpdate()
	; too late
endEvent

Function MyDebug(string mymessage)
	If (SCConfig.DebugMode)
		Debug.Notification(mymessage)
	EndIf
	Debug.Trace(mymessage)
EndFunction  

SPELL Property SpectatorZapperTarget  Auto  

SPELL Property SpectatorZapperArea  Auto  

SPELL Property SpectatorZapperMass  Auto  
