Scriptname mf_SpectatorCrowdsThreadBase extends Quest  

mf_SpectatorCrowdsConfig Property SCConfig Auto
mf_SpectatorCrowdsVariables Property SCConditional Auto
mf_SpectatorCrowdsFactions Property SCFactions Auto
mf_MoralityGuardWarnScript Property GuardWarnScript Auto
mf_SpectatorCrowdsGetSpectators Property GetSpectators Auto
Quest Property GuardWarn Auto
Quest Property ThisQuest Auto

string Property threadID Auto
sslThreadController Property SexController Auto

Keyword Property CityKeyword Auto

Actor Victim
Actor Aggressor
Actor akPlayer

slautilscr Property Arousal Auto
SexLabFramework Property SexLab Auto

int SpectatorCount = 0

MiscObject Property Gold Auto
Actor[] akSpectators
ReferenceAlias Property SexActorRef  Auto

Package Property ObserveSexPackage  Auto
Package Property ObserveSexReprobatePackage Auto 

int IsInInterior = 0
int SexIsProhibited = 0
int SexIsUnlawful = 0
bool SexInProgress = false
int SexTargetGender = 0
bool TargetIsMale = false
bool TargetIsFemale = false
bool TargetIsCreature = false

Bool SexActIsHeterosexual = false
Bool SexActIsGay = false
Bool SexActIsLesbian = false
Bool SexActIsBisexualMale = false
Bool SexActIsBisexualFemale = false
Bool SexActIsSoloMale = false
Bool SexActIsSoloFemale = false
Bool SexActContainsCreatures = false

; Prevent too many threads from running at once, otherwise the same spectators get added over and over
bool FindSpectatorLocked = false 

Event OnInit()
	akSpectators = New Actor[128]
	SpectatorCount = 0
	MyDebug("Spectator Crowds Thread " + MyThreadNumber() + " initialized successfully!")
EndEvent

int function MyThreadNumber()
	; we shouldn't see -1 because that means we didn't override this properly in the individual thread script
	return -1
endfunction

function SexStartDetected(sslThreadController myController, string myThreadID)
	if(!ThisQuest.IsRunning())
		ThisQuest.Start()
		threadID = MyThreadID
		SexController = myController
		Actor[] actorList = SexLab.HookActors(threadID)
		AddSexActor(actorList[0]) ; only this one in case of masturbation or other show
	endif
	GoToState("ActiveSpectator")
endfunction

function SexStopDetected()
	SexInProgress = false
endFunction

function SexEndDetected()
	SexInProgress = false
	;MyDebug("SexInProgress has been set to false")
	GoToState("")
endfunction

Function FindSpectator()
	FindSpectatorLocked = true
	;MyDebug("MoralityMonitor FindSpectator")

 	Actor[] actorList = SexLab.HookActors(threadID)

	Debug.Trace("About to call GetSpectatorsNearestTarget")
	Actor[] MySpectators = GetSpectators.GetSpectatorsNearestTarget(actorList[0], SCConfig.ParticipantPerScan)

	; ------------ Call Guard --------------------
	if(SCConfig.MoralityGuardActive && SexIsUnlawful == 1 && SexInProgress)
		int i=0
	 	While(i < SCConfig.ParticipantPerScan)
		  	Actor akSpectator = MySpectators[i]	
		 	if(akSpectator != None && SexInProgress)
				if(akSpectator.IsGuard() && !GuardWarn.IsRunning())
					GuardWarn.Start()
					(GuardWarn as mf_MoralityGuardWarnScript).SetGuardTo(akSpectator, Aggressor)
				endif
		 	endif
		 	i += 1
 		endWhile
 	endif 
	
	; ------------- Call Spectator ----------------
 	;if(SCConfig.SpectatorCrowdActive && (SCConditional.PlayerIsVictim >= 0) && SexInProgress)
	if(SCConfig.SpectatorCrowdActive && SexInProgress)
		;Debug.Notification("MoralityMonitor CallSpectator")

	
		int i=0
		
	 	While((i < SCConfig.ParticipantPerScan) && SexInProgress) ; max akSpectatorRefs.Length
		  	Actor akSpectator = MySpectators[i]	
			if(akSpectator != None && SexInProgress)
				AddSpectator(akSpectator)
		 	endif
		 	i += 1
 		endWhile
 	endif
	FindSpectatorLocked = false
endFunction

Function AddSexActor(Actor aSexActor)
	SexActorRef.ForceRefTo(aSexActor) ;
endFunction

Function AddSpectator(Actor akSpectator)
	if(SpectatorCount < akSpectators.Length && SpectatorCount < SCConfig.MaxParticipant && SexInProgress)
		;Debug.Notification("Adding Spectator")
		akSpectators[SpectatorCount] = akSpectator
		AddSpectatorToSpectatorFactions(akSpectator)
		; Add to the default spectators faction
		akSpectator.AddToFaction(SCFactions.Spectators)
		ActorUtil.AddPackageOverride(akSpectator, ObserveSexPackage)
		ActorUtil.AddPackageOverride(akSpectator, ObserveSexReprobatePackage)
		akSpectator.EvaluatePackage()
		if SCConfig.SpectatorNotifications
			Debug.Notification(akSpectator.getLeveledActorBase().getName() + " has noticed a sex act in progress and is going to watch...")
		endif
		Debug.Trace(akSpectator.getLeveledActorBase().getName() + " has noticed a sex act in progress and is going to watch...")
		Arousal.UpdateActorExposure(akSpectator, Utility.RandomInt(1, 10))
		SpectatorCount += 1
	endif
endFunction

Function MyDebug(string mymessage)
	If (SCConfig.DebugMode)
		Debug.Notification(mymessage)
	EndIf
	Debug.Trace(mymessage)
EndFunction

Function AddSpectatorToSpectatorFactions(Actor aSpectator)
	;Actor akSexActor = SexActorRef.GetRef() As Actor

	string factionupdate = "Adding Factions for Spectator " + aSpectator.getLeveledActorBase().getName() + ":" 
	

	factionupdate = factionupdate + " Spectators, "
	; Add to the sex prohibited faction
	If (SexIsProhibited == 1)
		aSpectator.AddToFaction(SCFactions.SexActIsProhibited)
		factionupdate = factionupdate + " SexProhibited, "
	endIf
	If (IsInInterior == 1)
		aSpectator.AddToFaction(SCFactions.SexActLocationIndoors)
		factionupdate = factionupdate + " Indoors, "
	Else
		aSpectator.AddToFaction(SCFactions.SexActLocationPublic)
		factionupdate = factionupdate + " Public, "
	EndIf

	Faction MaleTarget = SCFactions.SexTargetType[0]
	Faction FemaleTarget = SCFactions.SexTargetType[1]
	Faction CreatureTarget = SCFactions.SexTargetType[2]
	if (TargetIsMale)
		aSpectator.AddToFaction(MaleTarget)
		factionupdate = factionupdate + " MaleTarget, "
	elseif (TargetIsFemale)
		aSpectator.AddToFaction(FemaleTarget)
		factionupdate = factionupdate + " FemaleTarget, "
	elseif (TargetIsCreature)
		aSpectator.AddToFaction(CreatureTarget)
		factionupdate = factionupdate + " CreatureTarget, "
	endIf


	Faction SpectatorOrientation = SCFactions.SpectatorOrientation
	int SpectatorOrientationValue = Arousal.GetGenderPreference(aSpectator)
	bool SpectatorIsGay = false
	bool SpectatorIsLesbian = false
	bool SpectatorIsStraight = false
	bool SpectatorIsBisexual = false
	int SpectatorGender = SexLab.GetGender(aSpectator)
	if (SpectatorOrientationValue == 0)
		if (SpectatorGender == 0)
			SpectatorIsGay = true
		elseif (SpectatorGender == 1)
			SpectatorIsStraight = true
		endif
		factionupdate = factionupdate + " PrefersMen, "
	elseif (SpectatorOrientationValue == 1)
		if (SpectatorGender == 1)
			SpectatorIsLesbian = true
		elseif (SpectatorGender == 1)
			SpectatorIsStraight = true
		endif
		factionupdate = factionupdate + " PrefersWomen, "
	elseif (SpectatorOrientationValue == 2)
		SpectatorIsBisexual = true
		factionupdate = factionupdate + " IsBisexual, "
	endif
	aSpectator.SetFactionRank(SpectatorOrientation, SpectatorOrientationValue)

	; SexActOrientation[0] : Sex Act Is Heterosexual
	; SexActOrientation[1] : Sex Act Is Gay
	; SexActOrientation[2] : Sex Act Is Lesbian
	; SexActOrientation[3] : Sex Act Is Bi Male
	; SexActOrientation[4] : Sex Act Is Bi Female
	; SexActOrientation[5] : Sex Act is solo male
	; SexActOrientation[6] : Sex Act is solo female

	If (SexActIsHeterosexual)
		aSpectator.AddToFaction(SCFactions.SexActOrientation[0])
		factionupdate = factionupdate + " SexActIsHeterosexual, "
	elseif (SexActIsGay)
		aSpectator.AddToFaction(SCFactions.SexActOrientation[1])
		factionupdate = factionupdate + " SexActIsGay, "
	elseif (SexActIsLesbian)
		aSpectator.AddToFaction(SCFactions.SexActOrientation[2])
		factionupdate = factionupdate + " SexActIsLesbian, "
	elseif (SexActIsBisexualMale)
		aSpectator.AddToFaction(SCFactions.SexActOrientation[3])
		factionupdate = factionupdate + " SexActIsBiMale, "
	elseif (SexActIsBisexualFemale)
		aSpectator.AddToFaction(SCFactions.SexActOrientation[4])
		factionupdate = factionupdate + " SexActIsBiFemale, "
	elseif (SexActIsSoloMale)
		aSpectator.AddToFaction(SCFactions.SexActOrientation[5])
		factionupdate = factionupdate + " SexActIsSoloMale, "
	elseif (SexActIsSoloFemale)
		aSpectator.AddToFaction(SCFactions.SexActOrientation[6])
		factionupdate = factionupdate + " SexActIsSoloFemale, "
	endIf

	If (SexActContainsCreatures)
		aSpectator.AddToFaction(SCFactions.SexActContainsCreatures)
		factionupdate = factionupdate + " SexActContainsCreatures, "
	endIf

	float SpectatorPurity = SexLab.GetPurity(aSpectator)
	float SpectatorArousal = Arousal.GetActorArousal(aSpectator)

	Bool SpectatorLikesSexAct = true

	if (SCConfig.GaySpectatorsDislikeLesbianSex && SexActIsLesbian && SpectatorIsGay)
		SpectatorLikesSexAct = false
	elseif (SCConfig.LesbianSpectatorsDislikeGaySex && SexActIsGay && SpectatorIsLesbian)
		SpectatorLikesSexAct = false
	elseif (SCConfig.StraightMaleSpectatorsDislikeGaySex && SexActIsGay && SpectatorIsStraight && aSpectator.GetActorBase().GetSex() == 0)
		SpectatorLikesSexAct = false
	elseif (SCConfig.StraightFemaleSpectatorsDislikeLesbianSex && SexActIsLesbian && SpectatorIsStraight && aSpectator.GetActorBase().GetSex() == 1)
		SpectatorLikesSexAct = false
	elseif (SexIsProhibited)
		if (SexActContainsCreatures && SCConfig.CreatureSexProhibited)
			bool OverrideSuccessful = false
			if ((SCConfig.EnableCreatureSexPurityOverride && SpectatorPurity <= SCConfig.CreatureSexPurityOverrideThreshold) || (SCConfig.EnableCreatureSexArousalOverride && SpectatorArousal >= SCConfig.CreatureSexArousalOverrideThreshold))
				OverrideSuccessful = true
			endif
			if (!OverrideSuccessful)
				SpectatorLikesSexAct = false
			endif
		else ; must be city sex prohibited since it's the only other thing prohibited
			bool OverrideSuccessful = false
			if ((SCConfig.EnableCitySexPurityOverride && SpectatorPurity <= SCConfig.CitySexPurityOverrideThreshold) || (SCConfig.EnableCitySexArousalOverride && SpectatorArousal >= SCConfig.CitySexArousalOverrideThreshold))
				OverrideSuccessful = true
			endif
			if (!OverrideSuccessful)
				SpectatorLikesSexAct = false
			endif
		endif
	endif

	if (SpectatorLikesSexAct)
		aSpectator.AddToFaction(SCFactions.SpectatorLikesSexAct)
		factionupdate = factionupdate + " SpectatorLikesSexAct, "					
	endif
		
	factionupdate = factionupdate + " DONE."
	MyDebug(factionupdate)

	UpdateSexTypeFactions(aSpectator)

endFunction

Function UpdateSexTypeFactions(Actor aSpectator)
	; SexActTags[0] : Blowjob
	; SexActTags[1] : Cunnilingus
	; SexActTags[2] : Anal
	; SexActTags[3] : Vaginal
	; SexActTags[4] : Threesome
	; SexActTags[5] : Masturbation
	Faction Blowjob = SCFactions.SexActTags[0]
	Faction Cunnilingus = SCFactions.SexActTags[1]
	Faction Anal = SCFactions.SexActTags[2]
	Faction Vaginal = SCFactions.SexActTags[3]
	Faction Threesome = SCFactions.SexActTags[4]
	Faction Masturbation = SCFactions.SexActTags[5]

	sslBaseAnimation currentAnim = SexLab.HookAnimation(threadID)

	string factionupdate = "Updating Factions for Spectator " + aSpectator.getLeveledActorBase().getName() + ":" 
	string factionsadded = "ADDED: "
	string factionsremoved = " : REMOVED: "

	; this can change during the sequence so it needs to be checked repeatedly.
	if (currentAnim.HasTag("Masturbation") && !aSpectator.IsInFaction(Masturbation))
		aSpectator.AddToFaction(Masturbation)
		factionsadded = factionsadded + "Masturbation, "
	elseif (!currentAnim.HasTag("Masturbation") && aSpectator.IsInFaction(Masturbation))
		aSpectator.RemoveFromFaction(Masturbation)
		factionsremoved = factionsremoved + "Masturbation, "
	EndIf

	if (currentAnim.HasTag("Threesome") && !aSpectator.IsInFaction(Threesome))
		aSpectator.AddToFaction(Threesome)
		factionsadded = factionsadded + "Threesome, "
	elseif (!currentAnim.HasTag("Threesome") && aSpectator.IsInFaction(Threesome))
		aSpectator.RemoveFromFaction(Threesome)
		factionsremoved = factionsremoved + "Threesome, "
	EndIf

	if (currentAnim.HasTag("Vaginal") && !aSpectator.IsInFaction(Vaginal))
		aSpectator.AddToFaction(Vaginal)
		factionsadded = factionsadded + "Vaginal, "
	elseif (!currentAnim.HasTag("Vaginal") && aSpectator.IsInFaction(Vaginal))
		aSpectator.RemoveFromFaction(Vaginal)
		factionsremoved = factionsremoved + "Vaginal, "
	EndIf

	if (currentAnim.HasTag("Anal") && !aSpectator.IsInFaction(Anal))
		aSpectator.AddToFaction(Anal)
		factionsadded = factionsadded + "Anal, "
	elseif (!currentAnim.HasTag("Anal") && aSpectator.IsInFaction(Anal))
		aSpectator.RemoveFromFaction(Anal)
		factionsremoved = factionsremoved + "Anal, "
	EndIf

	if (currentAnim.HasTag("Cunnilingus") && !aSpectator.IsInFaction(Cunnilingus))
		aSpectator.AddToFaction(Cunnilingus)
		factionsadded = factionsadded + "Cunnilingus, "
	elseif (!currentAnim.HasTag("Cunnilingus") && aSpectator.IsInFaction(Cunnilingus))
		aSpectator.RemoveFromFaction(Cunnilingus)
		factionsremoved = factionsremoved + "Cunnilingus, "
	EndIf

	if (currentAnim.HasTag("Blowjob") && !aSpectator.IsInFaction(Blowjob))
		aSpectator.AddToFaction(Blowjob)
		factionsadded = factionsadded + "Blowjob, "
	elseif (!currentAnim.HasTag("Blowjob") && aSpectator.IsInFaction(Blowjob))
		aSpectator.RemoveFromFaction(Blowjob)
		factionsremoved = factionsremoved + "Blowjob, "
	EndIf

	if (currentAnim.HasTag("Aggressive") && !aSpectator.IsInFaction(SCFactions.SexActIsAggressive))
		aSpectator.AddToFaction(SCFactions.SexActIsAggressive)
		factionsadded = factionsadded + "Aggressive, "
	elseif (!currentAnim.HasTag("Aggressive") && aSpectator.IsInFaction(SCFactions.SexActIsAggressive))
		aSpectator.RemoveFromFaction(SCFactions.SexActIsAggressive)
		factionsremoved = factionsremoved + "Aggressive, "
	EndIf

	;MyDebug(factionupdate + factionsadded + factionsremoved + " DONE!")

EndFunction

Function RemoveSpectatorFromAdditionalFactions(Actor aSpectator)
	aSpectator.RemoveFromFaction(SCFactions.SexActOrientation[0])
	aSpectator.RemoveFromFaction(SCFactions.SexActOrientation[1])
	aSpectator.RemoveFromFaction(SCFactions.SexActOrientation[2])
	aSpectator.RemoveFromFaction(SCFactions.SexActOrientation[3])
	aSpectator.RemoveFromFaction(SCFactions.SexActOrientation[4])
	aSpectator.RemoveFromFaction(SCFactions.SexActOrientation[5])
	aSpectator.RemoveFromFaction(SCFactions.SexActOrientation[6])
	aSpectator.RemoveFromFaction(SCFactions.SpectatorOrientation)
	aSpectator.RemoveFromFaction(SCFactions.SexTargetType[0])
	aSpectator.RemoveFromFaction(SCFactions.SexTargetType[1])
	aSpectator.RemoveFromFaction(SCFactions.SexTargetType[2])
	aSpectator.RemoveFromFaction(SCFactions.SexActTags[0])
	aSpectator.RemoveFromFaction(SCFactions.SexActTags[1])
	aSpectator.RemoveFromFaction(SCFactions.SexActTags[2])
	aSpectator.RemoveFromFaction(SCFactions.SexActTags[3])
	aSpectator.RemoveFromFaction(SCFactions.SexActTags[4])
	aSpectator.RemoveFromFaction(SCFactions.SexActTags[5])
	aSpectator.RemoveFromFaction(SCFactions.SexActContainsCreatures)
	aSpectator.RemoveFromFaction(SCFactions.SexActIsAggressive)
	aSpectator.RemoveFromFaction(SCFactions.SexActIsProhibited)
	aSpectator.RemoveFromFaction(SCFactions.SexActLocationIndoors)
	aSpectator.RemoveFromFaction(SCFactions.SexActLocationPublic)
	aSpectator.RemoveFromFaction(SCFactions.SpectatorLikesSexAct)

	;MyDebug("Factions cleaned up for spectator " + aSpectator.getLeveledActorBase().getName())

endFunction

Function IfArousedMasturbate(Actor aSpectator)
	Debug.Notification("Checking " + aSpectator.getLeveledActorBase().getName() + " for arousal. Arousal is " + Arousal.GetActorArousal(aSpectator))
	If (Arousal.GetActorArousal(aSpectator) > 0)
		StartMasturbation(aSpectator)
		Debug.Notification("StartMasturbation for actor " + aSpectator.getLeveledActorBase().getName() + " has been called.")
	EndIf
endFunction

Function StartMasturbation(Actor Masturbator)
	If (Masturbator == None)
		Debug.Trace(self + ": StartMasturbation, Error NONE actor")
		return
	ElseIf (Masturbator.IsChild())
		return
	ElseIf ((Masturbator.is3DLoaded()) && (!((Masturbator.isOnMount()) || (Masturbator.isInCombat()))))
		Actor[] mastActorArray = new Actor[1]
		sslBaseAnimation[] animations
		If (Masturbator.GetLeveledActorBase().GetSex() == 0)
			animations = SexLab.GetAnimationsByTag(1, "Masturbation", "M")
		Else
			animations = SexLab.GetAnimationsByTag(1, "Masturbation", "F")
		EndIf
		mastActorArray[0] = Masturbator
		int myResult = sexlab.startSex(mastActorArray, animations, none, none)

		if (myResult >= 0)
			Debug.notification(Masturbator.getLeveledActorBase().getName() + " is highly aroused and has started masturbating.")
		else
			Debug.Trace(Masturbator.getLeveledActorBase().getName() + " failed to start masturbating due to an error.")
		EndIf
	EndIf
EndFunction

State ActiveSpectator
	Event OnBeginState()
		;MyDebug("MoralityMonitorMainScript OnBeginState")

		SexInProgress = true
		
		akPlayer = SexLab.PlayerRef
		Victim = SexController.GetVictim()
		Aggressor = none
	
		IsInInterior = 0
		SexIsProhibited = 0
		SexIsUnlawful = 0
		SCConditional.PlayerIsVictim = 0
		SCConditional.CreatureSexIsProhibited = 0
		If (SCConfig.CreatureSexProhibited)
			SCConditional.CreatureSexIsProhibited = 1
		endIf
		SCConditional.CitySexIsProhibited = 0
		If (SCConfig.CitySexProhibited)
			SCConditional.CitySexIsProhibited = 1
		endIf
		
		Actor akSexActor = SexActorRef.GetRef() As Actor
		SexTargetGender = SexLab.GetGender(akSexActor)
		TargetIsMale = false
		TargetIsFemale = false
		TargetIsCreature = false
		if (SexTargetGender == 0)
			TargetIsMale = true
			MyDebug("Sex Target is Male")
		elseif (SexTargetGender == 1)
			TargetIsFemale = true
			MyDebug("Sex Target is Female")
		elseif (SexTargetGender == 2)
			TargetIsCreature = true
			MyDebug("Sex Target is Creature")
		endIf

		Actor[] actorList = SexLab.HookActors(threadID)
		int[] SexActorCounts = SexLab.GenderCount(actorList)
		int NumberOfMales = SexActorCounts[0]
		int NumberOfFemales = SexActorCounts[1]
		int NumberOfCreatures = SexActorCounts[2]
		
		SexActIsHeterosexual = false
		SexActIsGay = false
		SexActIsLesbian = false
		SexActIsBisexualMale = false
		SexActIsBisexualFemale = false
		SexActIsSoloMale = false
		SexActIsSoloFemale = false
		SexActContainsCreatures = false
		
		if (NumberOfMales > 1 && NumberOfFemales == 0)
			SexActIsGay = true
			MyDebug("Sex Act is Gay")
		elseif (NumberOfFemales > 1 && NumberOfMales == 0)
			SexActIsLesbian = true
			MyDebug("Sex Act is Lesbian")
		elseif (NumberOfMales==1 && NumberOfFemales==0 && NumberOfCreatures == 0)
			SexActIsSoloMale = true
			MyDebug("Sex Act is Solo Male")
		elseif (NumberOfMales==0 && NumberOfFemales==1 && NumberOfCreatures == 0)
			SexActIsSoloFemale = true
			MyDebug("Sex Act is Solo Male")
		elseif ((NumberOfMales==1 && NumberOfFemales==1) || (NumberOfMales == 2 && TargetIsFemale) || (NumberOfFemales == 2 && TargetIsMale))
			SexActIsHeterosexual = true
			MyDebug("Sex Act is Heterosexual")
		elseif (NumberOfMales == 2 && NumberOfFemales == 1 && TargetIsMale)
			SexActIsBisexualMale = true
			MyDebug("Sex Act is Bisexual Male")
		elseif (NumberOfFemales == 2 && NumberOfMales == 1 && TargetIsFemale)
			SexActIsBisexualFemale = true
			MyDebug("Sex Act is Bisexual Female")
		endif

		if (NumberOfCreatures > 0)
			SexActContainsCreatures = true
			if (SCConfig.CreatureSexProhibited)
				SexIsProhibited = 1
			endIf
		endif
		
		Cell akCell = akPlayer.GetParentCell()
		if(akCell.IsInterior())
			IsInInterior = 1
			; consensual sex permited in interior
		else
			Location akLocation = akPlayer.GetCurrentLocation()
		 	if(akLocation.HasKeyWord(CityKeyword))
				if (SCConfig.CitySexProhibited)
					SexIsProhibited = 1
				endif
				if (SCConfig.CitySexUnlawful)
					SexIsUnlawful = 1
				endif
			else
				; everything is permitted in the wilds
			endif
		endif

		if(Victim != none)
			int aggressorPosition = sslUtility.WrapIndex(SexController.GetPosition(victim) + 1, 2)
			Aggressor = SexController.Positions[aggressorPosition]
			if (SCConfig.AggressiveSexUnlawful)
				SexIsUnlawful = 1
			endif
			if(Aggressor == akPlayer)
				SCConditional.PlayerIsVictim = -1
			else
				SCConditional.PlayerIsVictim = 1
			endif
		endIf

		FindSpectator()
		RegisterForSingleUpdate(SCConfig.ScanInterval)
	endEvent
 

	Event OnUpdate()
		;MyDebug("Event OnUpdate")
		if (!FindSpectatorLocked)
			FindSpectator()
		endIf
		if(SexInProgress)
   	    		RegisterForSingleUpdate(SCConfig.ScanInterval)
		else
			; do nothing, sex has ended
		endif 
	endEvent


	Event OnEndState()
		;MyDebug("Event OnEndState")
		if(GuardWarn.IsRunning())
			GuardWarnScript.EndOfSex()
	 	endif
		if(ThisQuest.IsRunning())
			;MyDebug("MoralityMonitor Ending ThisQuest")
			EndThisQuest()
			;MyDebug("MoralityMonitor Stopping ThisQuest")
			ThisQuest.Stop()
		endif
	endEvent
endState

Function EndThisQuest()
	;MyDebug("ThisQuestQuest Beginning EndThisQuest")
	int i = 0
	if(SCConditional.PlayerIsVictim == 0)
		while(i < SpectatorCount)
			; int amount = Utility.RandomInt(0, 5)
			;ObjectReference akSpectator = akSpectators[i].GetRef()
			; Arousal.UpdateActorArousal(akSpectator as Actor, 10)
			i+=1
		endWhile
	elseif(SCConditional.PlayerIsVictim == 1)

	else
	
	endif

	int k = SpectatorCount
	While(k > 0)
		k -= 1
		akSpectators[k].RemoveFromFaction(SCFactions.Spectators)
		ActorUtil.RemovePackageOverride(akSpectators[k], ObserveSexPackage)
		ActorUtil.RemovePackageOverride(akSpectators[k], ObserveSexReprobatePackage)
		akSpectators[k].EvaluatePackage()
		MyDebug(akSpectators[k].getLeveledActorBase().getName() + " has finished watching the sex act...")
	endWhile

	While(SpectatorCount > 0)
		SpectatorCount -= 1
		;MyDebug("Removing Spectator number: " + SpectatorCount + " with Name: " + akSpectators[SpectatorCount].getLeveledActorBase().getName())
		RemoveSpectatorFromAdditionalFactions(akSpectators[SpectatorCount])
		;akSpectators[SpectatorCount].Clear()
	endWhile
	;MyDebug("ThisQuestQuest Finished EndThisQuest")
endFunction



 


