Scriptname mf_MoralityGuardWarnScript extends Quest  

SexLabFramework Property SexLab Auto

mf_SpectatorCrowdsConfig Property SCConfig Auto
mf_SpectatorCrowdsMainScript Property SCMainScript Auto
mf_SpectatorCrowdsVariables Property SCConditional Auto
mf_SpectatorCrowdsThread00 Property PlayerThreadScript Auto
MiscObject Property Gold Auto

ReferenceAlias Property akPlayerRef Auto
ReferenceAlias Property akGuardRef Auto

Actor akAggressor
Actor akGuard
Actor akPlayer


Function SetGuardTo(Actor aGuard, Actor aggr = None)
	GoToState("InSex")
	Debug.Notification("A guard is coming your way...")
	
	akGuard = aGuard
	akGuardRef.ForceRefTo(akGuard)
	akPlayer = akPlayerRef.GetRef() as Actor
	akAggressor = aggr
endFunction


Function InterruptSex()
	;
endFunction

Function EndOfSex()
	;
endFunction


State InSex
 Function InterruptSex()
	GoToState("")
	if(PlayerThreadScript.SexController != None)
		PlayerThreadScript.SexController.EndAnimation(true)
		PlayerThreadScript.SexController = None
	endif
 endFunction
 
 Function EndOfSex()
	GoToState("")
 endFunction
endState


Function FollowMe()
	SCConditional.GuardFollowPlayer = 1
	akGuard.EvaluatePackage()
	;Debug.Notification("FollowMe issued.")
endFunction


Function StopFollow()
	SCConditional.GuardFollowPlayer = 0
	akGuard.EvaluatePackage()
	;Debug.Notification("StopFollow issued.")
endFunction


Function AddBounty(int amount)
	SCConditional.NumberOfOffence += 1
	akGuard.GetCrimeFaction().ModCrimeGold(amount)
endFunction


Function PayBribe(int amount)
	akPlayer.RemoveItem(gold, amount)
endFunction


Function PerformOral()
	StopFollow()

	bool[] equip0 = New bool[33]
 	bool[] equip1 = New bool[33]
 	int i=0
 	While(i < 33)
		equip0[i] = false
		equip1[i] = false
		i += 1
 	endWhile
 
 	equip0[0] = true ;head
	equip0[3] = true ;hand
	equip0[4] = true ;forearms
	equip0[9] = true ;shield
	equip0[14] = true ;face
	equip0[32] = true ;weapon
	
	equip1[2] = true ;body
	equip1[9] = true ;shield
	equip1[16] = true ;chest
	equip1[19] = true ;pelvis
	equip1[28] = true ;undergarment
	equip1[32] = true ;weapon	

  	sslBaseAnimation[] anims = SexLab.GetAnimationsByTag(2, "Blowjob", tagSuppress="Zaz")

	sslThreadModel th = SexLab.NewThread()
	th.AddActor(akPlayer)
	th.AddActor(akGuard)
	th.SetAnimations(anims)
	th.DisableLeadIn(true) 
	th.SetStrip(akPlayer, equip0)
	th.SetStrip(akGuard, equip1)
	th.SetHook("GetTime")
	th.StartThread()	
endFunction


Function GuardStartCombat(int amount = 0)
	if(SCConfig.GuardsAttackAggressors)
		if(akAggressor == None || akAggressor == akPlayer)
			akAggressor = akPlayer
			SCConditional.NumberOfOffence += 1	
			akGuard.GetCrimeFaction().ModCrimeGold(amount, true)
			akGuard.SendAssaultAlarm() ; with player	
		else
			akGuard.StartCombat(akAggressor)
		endif
	endif
endFunction
